#include <stdio.h>
#include <stdlib.h>
#include "dmcconv.h"

int DMCconv(double SampleStep, LONG nSampleSize){

	INT i,j;
	double	SampleCount;
	FILE*	ofp = NULL;
	LPSHORT	pW;
	INT	Min, Max;
	INT	temp;
	INT	DivPoint;
	INT	Multi;
	INT	Delta;
	INT	DMCshift, DMCsize, DMCbits;
	INT	nTotalSize;

//	if( SampleStep < 1.0 )
//		throw	"WAVEեΥץ󥰥졼Ȥ⤹ޤ\n";

//	Ϥ줿ǡΥå
#ifdef DEBUG
	printf(" --DMCrate  %d\n", DMCrate);
	printf(" --nVolume  %d\n", nVolume);
	printf(" --bVolume  %d\n", bVolume);
	printf(" --bSize    %d\n", bSize);
	printf(" --bPadding %d\n", bPadding);
	printf(" --pInFile  %s\n", pInFile);
	printf(" --pOutFile %s\n", pOutFile);
	printf(" --SampleStep %d\n", SampleStep);
	printf(" --nSampleSize %d\n", nSampleSize);
#endif

	// WAVEեΥǡMAXͤ
	pW = (SHORT*)lpBuffer;
	Min =  32767;
	Max = -32768;
	for( i = 0; i < nSampleSize; i++ ) {
		if( Min > (INT)*pW )
			Min = (INT)*pW;
		if( Max < (INT)*pW )
			Max = (INT)*pW;
		pW++;
	}

	// ʿͤ濴
	DivPoint = (Min+Max)/2;
	pW = (SHORT*)lpBuffer;

	// ǤäͤȤƼ
	if( abs( Min ) > abs( Max ) ) {
		Multi = abs(Min);
	} else {
		Multi = abs(Max);
	}

	// Ѵ
	if( bVolume && Multi ) {
		for( i = 0; i < nSampleSize; i++ ) {
			// 濴˰ưƥܥ塼Ĵ
			temp = nVolume*((INT)pW[i]-(Min+Max)/2)/100;
			// ͤ0x1000Ȥ
			temp = 0x800*temp/Multi + 0x800;
			if( temp < 0 )
				temp = 0;
			if( temp > 0x0FFF )
				temp = 0xFFF;

			pW[i] = (SHORT)temp;
		}
		Delta = 0x3F;	// DPCM
	} else {
		Delta = (pW[0]+0x8000)>>9;	// DPCM
	}
	printf( "DMC start value: $%02X\n", Delta );

	// DMCǡؤѴ
	if( (ofp = fopen( pOutFile, "wb" )) == NULL )
		errmes("ERROR: cannot open file.");

	i = 0;
	DMCshift = 8;
	DMCsize = 0;
	DMCbits = 0;

	pW = (SHORT*)lpBuffer;

	SampleCount = SampleStep;

	do {
		DMCbits >>= 1;

		if( pW[i] > Delta*(0x1000/0x40) ) {
			if( ++Delta > 0x3F )
				Delta = 0x3F;
			DMCbits |= 0x80;
		} else {
			if( --Delta < 0 )
				Delta = 0;
		}

		if( --DMCshift == 0 ) {
			fputc( DMCbits, ofp );

			DMCshift = 8;
			DMCbits = 0;
			DMCsize++;

			if( bPadding ) {
				// ѥǥ
				if( (DMCsize & 0x0FFF) == 0x0FF1 ) {
					for( j = 0; j < 0xF; j++ ) {
						fputc( 0, ofp );
						DMCsize++;
					}
				}
			}
		}

		SampleCount -= 1.0;
		while( SampleCount < 0.0 ) {
			SampleCount += SampleStep;
			if( ++i >= nSampleSize )
				break;
		}
	} while( i < nSampleSize );

	if( bPadding ) {
		// Х󥯥ˤʤͤ˥Ĥ˥ǡ
		nTotalSize = (DMCsize+16383)&~16383;

		do {
			fputc( 0, ofp );
			DMCsize++;
		} while( DMCsize < nTotalSize );

		printf( "Total: %dBanks(8K) $%02XBanks(16KHex) %dKBytes\n", DMCsize/8192, DMCsize/16384, DMCsize/1024 );
	} else if( bSize ) {
		// ˹礦褦˥ǡ
		if( DMCsize > 0xFF1 ) {
			printf( "Warning: over the max of DMC\n" );
		}
		nTotalSize = ((DMCsize+15)&0xFFFFFFF0)+1;
		do {
			fputc( 0x55, ofp );
			DMCsize++;
		} while( DMCsize < nTotalSize );

		printf( "Total: %d bytes\n", DMCsize );
		printf( "Len-reg value: %d ($%X)\n", nTotalSize>>4, nTotalSize>>4 );
	} else {
		printf( "Total: %d bytes\n", DMCsize );
	}

	fclose( ofp );

	printf( "Completed!!\n" );

	return 0;
}
