/**************************************************
   NSFTag ver 0.01 Copyright(C) 2005 BouKiCHi 
   ver 0.01 : 2005-04-02 : first edition
**************************************************/

#include <stdio.h>
#include <string.h>

int putNSFHeader(const char *fname)
{
	char head[0x80];
	FILE *in;
	in = fopen(fname,"rb");
	if (!in) {
		printf("File open error!(in)\n");
		return -1;
	}
	fread(head,0x04,1,in);
	if (memcmp(head,"NESM",0x04)) {
		printf("the file is not NSF format\n");
		return -1;
	}
	fseek(in,0x0e,SEEK_SET);
	fread(head,0x60,1,in);
	head[0x1f]='\0';
	head[0x3f]='\0';
	head[0x5f]='\0';
	printf("-------- file : %s --------\n"
	       "Title : %s\nArtist : %s\nCopyright : %s\n",
		fname,head,head+0x20,head+0x40);
	fclose(in);

	return 0;
}

int setNSFHeader(const char *fname,const char *name,
	const char *artist,const char *copy)
{
	char buf[0x80];
	FILE *app;
	app = fopen(fname,"r+b");
	if (!app) {
		printf("File open error!(apply)\n");
		return -1;
	}
	fread(buf,0x04,1,app);
	if (memcmp(buf,"NESM",0x04)) {
		printf("the file is not NSF format\n");
		return -1;
	}
	memset(buf,0,0x60);
	strcpy(buf,name);
	strcpy(buf+0x20,artist);
	strcpy(buf+0x40,copy);

	fseek(app,0x0e,SEEK_SET);
	fwrite(buf,0x60,1,app);
	fclose(app);

	printf("-------- file : %s --------\n",fname);


	return 0;
}

void appversion(void)
{
	printf("NSFTag version 0.01 Copyright 2005 BouKiCHi\n");
}

void usage(const char *appname)
{
	printf("\nUsage %s : [options] filenames...\n",appname);
	printf(" -t[title]\t\t set title string\n"
	       " -a[artist]\t\t set artist string\n"
	       " -c[copyright]\t\t set copyright string\n\n"
	       " -w\t\t\t set strings to file\n"
	       " -v\t\t\t view info in file\n"
	       " -?,-h\t\t\t display this help\n");
}

int main(int argc,char *argv[])
{
	int i;
	int flagWrite=0;

	char nam[64];
	char art[64];
	char cpy[64];

	if (argc<2) {
		appversion();
		usage(argv[0]);
		return -1;
	}

	for(i=1; i < argc; i++) {
		if (argv[i][0] == '-')
		{
			switch(argv[i][1])
			{
				case 'h':
			  case '?':
				appversion();
					usage(argv[0]);
				break;
				case 't':
					strcpy(nam,argv[i]+2);
				break;
				case 'a':
					strcpy(art,argv[i]+2);
				break;
				case 'c':
					strcpy(cpy,argv[i]+2);
				break;
				case 'v':
					flagWrite = 0;
				break;
				case 'w':
					flagWrite = 1;
				break;
				default:
					printf("Unknown option\n");
				break;
			}
		} 
		else
		{
		    if (flagWrite)
			setNSFHeader(argv[i],nam,art,cpy);
		    else
			putNSFHeader(argv[i]);
		}
		
	}
	return 0;
}



